require 'lib/class'
require 'lib/Vector2'

Camera = newclass('Camera')
function Camera:init()
	self.center = Vector2:new(0, 0)
	self.rotation = 0
	self.zoom = 1
end

function Camera:SetCenter(pos)
	self.center = pos
end

function Camera:SetRotation(angle)
	self.rotation = angle
end

function Camera:GetRotation()
	return self.rotation
end

function Camera:SetZoom(scale)
	self.zoom = scale
end

function Camera:onMousePressed(button)

end

function Camera:Update(dt)

end

function Camera:ToWorldSpace(point)
	local x,y = point.x, point.y
	x = x + self.center.x - (love.graphics.getWidth()/2)
	y = y + self.center.y - (love.graphics.getHeight()/2)

	return Vector2:new(x,y)
end

function Camera:Apply()
	love.graphics.push()

	local center_x = love.graphics.getWidth() / (2*self.zoom)
	local center_y = love.graphics.getHeight()/ (2*self.zoom)

	love.graphics.scale(self.zoom)
	love.graphics.translate(center_x, center_y)
	love.graphics.rotate(self.rotation)

	love.graphics.translate(-self.center.x, -self.center.y)
end

function Camera:Remove()
	love.graphics.pop()
end