require 'lib/class'

Event = newclass('Event')
function Event:init()
	self.callbacks = {}
end

function Event:Connect(callback, priority)
	self.callbacks[callback] = priority or 1
	return callback
end

function Event:Disconnect(callback)
	for i,v in pairs(self.callbacks) do 
		if v == callback then
			table.remove(self.callbacks, callback)
		end
	end
end

function Event:Fire(...)
	local sorted = {}
	for i,v in pairs(self.callbacks) do sorted[#sorted+1] = i end
	table.sort(sorted, function(a,b) 
		local a_p = self.callbacks[a]
		local b_p = self.callbacks[b]
		return a_p > b_p
	end)

	local consumed = false
	local consume = function() consumed = true	end
	local args = {...} args[#args+1] = consume
	local return_values = {}
	for i,v in pairs(sorted) do
		print(unpack(args))
		local return_val = v(unpack(args))

		if consumed then return return_Val end
		return_values[#return_values+1] = return_val
	end

	return return_values
end
