require 'lib/class'

Vector2 = newclass('Vector2')
function Vector2:init(x, y)
	self.x = x or 0
	self.y = y or 0
end

function Vector2:__add(other)
	if type(other) == 'number' then
		return Vector2:new(self.x + other, self.y + other)
	end
	return Vector2:new(self.x + other.x, self.y + other.y)
end

function Vector2:__sub(other)
	if type(other) == 'number' then
		return Vector2:new(self.x - other, self.y - other)
	end
	return Vector2:new(self.x - other.x, self.y - other.y)
end

function Vector2:__mul(other)
	if type(other) == 'number' then
		return Vector2:new(self.x * other, self.y * other)
	end
	return Vector2:new(self.x * other.x, self.y * other.y)
end

function Vector2:__div(other)
	if type(other) == 'number' then
		return Vector2:new(self.x / other, self.y / other)
	end
	return Vector2:new(self.x / other.x, self.y / other.y)
end

function Vector2:ToPolarCoordinates()
	local angle = math.atan2(self.y, self.x)
	local radius = math.sqrt(self.x * self.x + self.y * self.y)

	return angle, radius
end

function Vector2:FromPolarCoordinates(angle, radius)
	self.x = math.cos(angle) * radius
	self.y = math.sin(angle) * radius
end

function Vector2:GetSerialized()
	local data = {}
	data.x = self.x
	data.y = self.y
	return data
end

function Vector2:Deserialize(data)
	if data == nil then return end
	self.x = data.x or 0
	self.y = data.y or 0
end
