require 'lib/class'
require 'Camera'

MapsFolder = "assets/maps/"
Map = newclass('Map')
function Map:init(name)
	self.main_scale = 8
	love.graphics.setDefaultImageFilter("nearest","nearest")
	self.diffuse = love.graphics.newImage(MapsFolder .. name .. "/diffuse.png")
	self.width = self.diffuse:getWidth()
	self.height = self.diffuse:getHeight()
	self.collision_map = {}
	self.entities = {}

	local collision_data = love.image.newImageData(MapsFolder .. name .. "/collision.png")
	local mapFunc = function(x, y, r,g,b,a)
		if self.collision_map[x] == nil then self.collision_map[x] = {} end

		local collide = true
		if r == 255 and g == 255 and b == 255 then
			collide = false
		end
		self.collision_map[x][y] = collide
	end
	for i=0,collision_data:getWidth()-1 do
		for j=0,collision_data:getHeight()-1 do
			mapFunc(i,j, collision_data:getPixel(i,j))
		end
	end

	local entities_json = love.filesystem.read(MapsFolder .. name .. "/entities.json")
end

function Map:TestPointCollision(point)
	local x = math.floor(point.x / self.main_scale)
	local y = math.floor(point.y / self.main_scale)

	if x >= 0 and x < self.width  and y >= 0 and y < self.height then
		return self.collision_map[x][y]
	else
		return true
	end
end

function Map:Draw()
	love.graphics.draw(self.diffuse, 0, 0, 0, self.main_scale, self.main_scale)


end

local map1 = nil
local map1_coll = nil
local camera = Camera:new()

local clouds = nil
local clouds_quad = nil

local char_pos = Vector2:new(750,600)
function love.load()
	love.graphics.setBackgroundColor(4, 180, 215)
	test = Map:new("map1")
	camera:SetCenter(Vector2:new(750,512))
	camera:SetZoom(1)

	clouds = love.graphics.newImage("assets/clouds.png")
	clouds:setWrap('repeat','repeat')
	clouds_quad = love.graphics.newQuad(0, 0, love.graphics.getWidth(), love.graphics.getHeight(), clouds:getWidth(), clouds:getHeight())
end
t=0
function love.update(dt)
	t=t+dt
	camera:Update(dt)

	local speed = 100
	if love.keyboard.isDown('a') then
		local new_pos = Vector2:new(char_pos.x - dt * speed, char_pos.y)
		if test:TestPointCollision(new_pos + Vector2:new(-5, -5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(5, -5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(5, 5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(-5, 5)) == false then
			char_pos.x = new_pos.x
		end
	end
	if love.keyboard.isDown('d') then
		local new_pos = Vector2:new(char_pos.x + dt * speed, char_pos.y)
		if test:TestPointCollision(new_pos + Vector2:new(-5, -5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(5, -5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(5, 5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(-5, 5)) == false then
			char_pos.x = new_pos.x
		end
	end
	if love.keyboard.isDown('w') then
		local new_pos = Vector2:new(char_pos.x, char_pos.y - dt * speed)
		if test:TestPointCollision(new_pos + Vector2:new(-5, -5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(5, -5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(5, 5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(-5, 5)) == false then
			char_pos.y = new_pos.y
		end
	end
	if love.keyboard.isDown('s') then
		local new_pos = Vector2:new(char_pos.x, char_pos.y + dt * speed)
		if test:TestPointCollision(new_pos + Vector2:new(-5, -5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(5, -5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(5, 5)) == false and
		   test:TestPointCollision(new_pos + Vector2:new(-5, 5)) == false then
			char_pos.y = new_pos.y
		end
	end
	camera:SetCenter(char_pos)
end

function love.draw()
	clouds_quad:setViewport((-t*3.5) + camera.center.x/32, camera.center.y/32, love.graphics.getWidth(), love.graphics.getHeight())
	love.graphics.drawq(clouds, clouds_quad, 0, 0, 0, 16, 16)
	camera:Apply()

	

	test:Draw()
	love.graphics.circle('fill', char_pos.x,char_pos.y, 5, 32)
	camera:Remove()

--[[local m = Vector2:new(love.mouse.getX(), love.mouse.getY())
	local p = camera:ToWorldSpace(m)
	if test:TestPointCollision(p) then
		love.graphics.setColor(255, 0, 0, 150)
	else 
		love.graphics.setColor(0, 255, 0, 150)
	end
	love.graphics.circle('fill', m.x, m.y, 10, 64)
	love.graphics.setColor(255,255,255,255)
]]

	
end